--׽Ʈ ̺
--DROP TABLE TB_PKG_TEST;

CREATE TABLE TB_PKG_TEST (
    USER_ID     VARCHAR2(50),
    USER_NAME   VARCHAR2(100),
    CONSTRAINT  PK_PKG_TEST PRIMARY KEY (USER_ID)
);

--DROP PROCEDURE UP_NO_PKG_TEST;

CREATE OR REPLACE PROCEDURE UP_NO_PKG_TEST  (P_USER_ID  TB_PKG_TEST.USER_ID%TYPE)
IS
    V_USER_NAME TB_PKG_TEST.USER_NAME%TYPE;
BEGIN
    SELECT USER_NAME
    INTO V_USER_NAME
    FROM TB_PKG_TEST
    WHERE USER_ID = P_USER_ID;
    
    DBMS_OUTPUT.PUT_LINE(V_USER_NAME);
    
END;
/

--DROP FUNCTION UF_NO_PKG_TEST;

CREATE OR REPLACE FUNCTION UF_NO_PKG_TEST  (P_USER_ID  TB_PKG_TEST.USER_ID%TYPE)
RETURN TB_PKG_TEST.USER_NAME%TYPE
IS
    V_USER_NAME TB_PKG_TEST.USER_NAME%TYPE;
BEGIN
    SELECT USER_NAME
    INTO V_USER_NAME
    FROM TB_PKG_TEST
    WHERE USER_ID = P_USER_ID;
    
    RETURN V_USER_NAME;
END;
/

--DROP PACKAGE PKG_TEST;

CREATE OR REPLACE PACKAGE PKG_TEST
AS
    PROCEDURE UP_PKG_TEST (P_USER_ID TB_PKG_TEST.USER_ID%TYPE);
    
    FUNCTION UF_PKG_TEST (P_USER_ID TB_PKG_TEST.USER_ID%TYPE) RETURN TB_PKG_TEST.USER_NAME%TYPE;

END PKG_TEST;
/

CREATE OR REPLACE PACKAGE BODY PKG_TEST
AS
    PROCEDURE  UP_PKG_TEST  (P_USER_ID  TB_PKG_TEST.USER_ID%TYPE)
    IS
        V_USER_NAME TB_PKG_TEST.USER_NAME%TYPE;
    BEGIN
        SELECT USER_NAME
        INTO V_USER_NAME
        FROM TB_PKG_TEST
        WHERE USER_ID = P_USER_ID;
        
        DBMS_OUTPUT.PUT_LINE(V_USER_NAME);
        
    END;


    FUNCTION UF_PKG_TEST  (P_USER_ID  TB_PKG_TEST.USER_ID%TYPE)
    RETURN TB_PKG_TEST.USER_NAME%TYPE
    IS
        V_USER_NAME TB_PKG_TEST.USER_NAME%TYPE;
    BEGIN
        SELECT USER_NAME
        INTO V_USER_NAME
        FROM TB_PKG_TEST
        WHERE USER_ID = P_USER_ID;
    
        RETURN V_USER_NAME;
    END;

END PKG_TEST;
/

--Ȯ
SELECT OBJECT_NAME, OBJECT_TYPE, STATUS
FROM ALL_OBJECTS
WHERE OWNER = 'HR'
AND OBJECT_TYPE = ANY('PROCEDURE', 'FUNCTION', 'PACKAGE', 'PACKAGE BODY');

--̺ ÷ ߰ USER_NICK
ALTER TABLE TB_PKG_TEST
ADD USER_NICK  VARCHAR2(100);

--Ȯ (10g   INVALID)
SELECT OBJECT_NAME, OBJECT_TYPE, STATUS
FROM ALL_OBJECTS
WHERE OWNER = 'HR'
AND OBJECT_TYPE = ANY('PROCEDURE', 'FUNCTION', 'PACKAGE', 'PACKAGE BODY');

--
ALTER PACKAGE PKG_TEST COMPILE;

ALTER PROCEDURE UP_NO_PKG_TEST COMPILE;

ALTER FUNCTION UF_NO_PKG_TEST COMPILE;

--Ű  
DROP PACKAGE PKG_TEST;

DROP PACKAGE BODY PKG_TEST;

--Ű ٽ 

--Ű Ȯ
SELECT OBJECT_NAME, OBJECT_TYPE, STATUS
FROM ALL_OBJECTS
WHERE OWNER = 'HR'
AND OBJECT_TYPE = ANY('PROCEDURE', 'FUNCTION', 'PACKAGE', 'PACKAGE BODY');


--Ű 
-- Է
SELECT *
FROM TB_PKG_TEST;

INSERT INTO TB_PKG_TEST(USER_ID, USER_NAME, USER_NICK)
VALUES ('HONG', 'ȫ浿', 'ȫ浿');

INSERT INTO TB_PKG_TEST(USER_ID, USER_NAME, USER_NICK)
VALUES ('HONG1', 'ȫ浿1', 'ȫ浿');

INSERT INTO TB_PKG_TEST(USER_ID, USER_NAME, USER_NICK)
VALUES ('HONG2', 'ȫ浿2', 'ȫ浿');

COMMIT;

--Ű ȿ UP_PKG_TEST 
EXEC PKG_TEST.UP_PKG_TEST('HONG');

--Ű ȿ UF_PKG_TEST 
SELECT PKG_TEST.UF_PKG_TEST('HONG1')
FROM DUAL;


--Ű Ŀ ϴ 
-- Ŀ
--DROP PACKAGE PKG_CUR_TEST;

CREATE OR REPLACE PACKAGE PKG_CUR_TEST
AS
    -- 
    C_NAME  VARCHAR2(200) := 'ȫ浿';
    
    --Ű  Ŀ 
    CURSOR USER_CUR_SPEC (
        P_USER_ID IN TB_PKG_TEST.USER_ID%TYPE
    )
    IS
    SELECT *
    FROM TB_PKG_TEST
    WHERE USER_ID = P_USER_ID;
    
    --ID ν 
    PROCEDURE  UP_PKG_ID_SPEC_TEST  (P_USER_ID  TB_PKG_TEST.USER_ID%TYPE);
    
    --ID ν 
    PROCEDURE  UP_PKG_ID_BODY_TEST  (P_USER_ID  TB_PKG_TEST.USER_ID%TYPE);

    --NAME ν 
    PROCEDURE  UP_PKG_NAME_TEST  (P_USER_NAME  TB_PKG_TEST.USER_NAME%TYPE);

END PKG_CUR_TEST;


CREATE OR REPLACE PACKAGE BODY PKG_CUR_TEST
AS
    -- ʱȭ 
    G_NAME  VARCHAR2(200) := C_NAME;
    
    --Ŀ 
    CURSOR  CUR_FIX
    IS
    SELECT *
    FROM TB_PKG_TEST
    WHERE USER_NAME LIKE C_NAME || '%';

    CURSOR USER_CUR_BODY (
        P_USER_ID IN TB_PKG_TEST.USER_ID%TYPE
    )
    IS
    SELECT *
    FROM TB_PKG_TEST
    WHERE USER_ID LIKE P_USER_ID || '%';

    PROCEDURE  UP_PKG_ID_SPEC_TEST  (P_USER_ID  TB_PKG_TEST.USER_ID%TYPE)
    IS
        V_USER_NAME TB_PKG_TEST.USER_NAME%TYPE;
        TEST_RECORD USER_CUR_SPEC%ROWTYPE;
    BEGIN
        OPEN USER_CUR_SPEC (P_USER_ID);
        
        LOOP
            FETCH USER_CUR_SPEC INTO TEST_RECORD;
            EXIT WHEN USER_CUR_SPEC%NOTFOUND;
            
            DBMS_OUTPUT.PUT_LINE(TEST_RECORD.USER_ID || ' : (' || TEST_RECORD.USER_NAME || ')');
            
        END LOOP;
        
        CLOSE USER_CUR_SPEC;        
    
    END;

    PROCEDURE  UP_PKG_ID_BODY_TEST  (P_USER_ID  TB_PKG_TEST.USER_ID%TYPE)
    IS
        V_USER_NAME TB_PKG_TEST.USER_NAME%TYPE;
        TEST_RECORD USER_CUR_BODY%ROWTYPE;
    BEGIN
        OPEN USER_CUR_BODY (P_USER_ID);
        
        LOOP
            FETCH USER_CUR_BODY INTO TEST_RECORD;
            EXIT WHEN USER_CUR_BODY%NOTFOUND;
            
            DBMS_OUTPUT.PUT_LINE(TEST_RECORD.USER_ID || ' : (' || TEST_RECORD.USER_NAME || ')');
            
        END LOOP;
        
        CLOSE USER_CUR_BODY;        
    
    END;

    PROCEDURE  UP_PKG_NAME_TEST  (P_USER_NAME  TB_PKG_TEST.USER_NAME%TYPE)
    IS
        V_USER_NAME TB_PKG_TEST.USER_NAME%TYPE;
        TEST_RECORD CUR_FIX%ROWTYPE;
    BEGIN
        OPEN CUR_FIX;
        
        LOOP
            FETCH CUR_FIX INTO TEST_RECORD;
            EXIT WHEN CUR_FIX%NOTFOUND;
            
            DBMS_OUTPUT.PUT_LINE(TEST_RECORD.USER_ID || ' : (' || TEST_RECORD.USER_NAME || ')');
            
        END LOOP;
        
        CLOSE CUR_FIX;
    
    END;


END PKG_CUR_TEST;
/

--Ű 
EXEC PKG_CUR_TEST.UP_PKG_NAME_TEST('');

EXEC PKG_CUR_TEST.UP_PKG_ID_BODY_TEST('HONG');

EXEC PKG_CUR_TEST.UP_PKG_ID_SPEC_TEST('HONG');

--Ŀ
--DROP PACKAGE PKG_REF_CUR_TEST;

CREATE OR REPLACE PACKAGE PKG_REF_CUR_TEST
AS
    --Ŀ 
    TYPE REF_USER_CUR IS REF CURSOR;
    
    -- Ŀ   ν  
    PROCEDURE  UP_OPEN_REF_CUR (P_REF_CUR OUT REF_USER_CUR);
    
    --UP_OPEN_REF_CUR ؼ  Ŀ ̿Ͽ Ѵ ν
    PROCEDURE  UP_PRT_REF_CUR (P_MAX_LOOP PLS_INTEGER);

END PKG_REF_CUR_TEST;
/

CREATE OR REPLACE PACKAGE BODY PKG_REF_CUR_TEST
AS

    PROCEDURE  UP_OPEN_REF_CUR (P_REF_CUR OUT REF_USER_CUR)
    IS
    BEGIN
        OPEN P_REF_CUR
        FOR
        SELECT *
        FROM TB_PKG_TEST
        ORDER BY USER_ID;
        
    END UP_OPEN_REF_CUR;
    
    PROCEDURE  UP_PRT_REF_CUR (P_MAX_LOOP PLS_INTEGER)
    IS
        V_RTN_CUR REF_USER_CUR;
        V_RECORD TB_PKG_TEST%ROWTYPE;
    BEGIN
        UP_OPEN_REF_CUR (V_RTN_CUR);
        
        FOR I IN 1 .. P_MAX_LOOP
        LOOP
            FETCH V_RTN_CUR
            INTO V_RECORD;
            
            EXIT WHEN V_RTN_CUR%NOTFOUND;
            
            DBMS_OUTPUT.PUT_LINE(V_RECORD.USER_ID || ' : (' || V_RECORD.USER_NAME || ')');        
        
        END LOOP;

        CLOSE V_RTN_CUR;

    END UP_PRT_REF_CUR;

END PKG_REF_CUR_TEST;
/

--ν 
EXEC PKG_REF_CUR_TEST.UP_PRT_REF_CUR (1);

EXEC PKG_REF_CUR_TEST.UP_PRT_REF_CUR (3);

--Ʈ
--ǰ ̺
--DROP TABLE TB_PROD;

CREATE TABLE TB_PROD (
    PROD_ID     VARCHAR2(10),
    PROD_NAME   VARCHAR2(30),
    JAN_CNT     NUMBER,
    CONSTRAINT PK_PROD PRIMARY KEY (PROD_ID)
);

--԰ ̺
--DROP TABLE TB_INPUT;

CREATE TABLE TB_INPUT (
    IN_DATE     VARCHAR2(10),
    IN_SEQ      VARCHAR2(3),
    PROD_ID     VARCHAR2(10),
    IN_CNT      NUMBER,
    CONSTRAINT PK_INPUT PRIMARY KEY (IN_DATE, IN_SEQ)
);

-- ̺
--DROP TABLE TB_OUTPUT;

CREATE TABLE TB_OUTPUT (
    OUT_DATE    VARCHAR2(10),
    OUT_SEQ     VARCHAR2(3),
    PROD_ID     VARCHAR2(10),
    OUT_CNT     NUMBER,
    CONSTRAINT PK_OUTPUT PRIMARY KEY (OUT_DATE, OUT_SEQ)
);

--  Ʈ 
--ǰ 丮 ̺ 
--DROP TABLE TB_PROD_HIST;

CREATE TABLE TB_PROD_HIST (
    LOG_DATE    TIMESTAMP,
    WORK_USER   VARCHAR2(100),
    EVENT       VARCHAR2(100)    
);


--  Ʈ 
CREATE OR REPLACE TRIGGER TR_TB_PROD_STMT
BEFORE INSERT OR UPDATE OR DELETE ON TB_PROD
DECLARE
   V_EVENT TB_PROD_HIST.EVENT%TYPE;
BEGIN
    IF INSERTING THEN
        V_EVENT := 'INSERT';
    ELSIF UPDATING THEN
        V_EVENT := 'UPDATE';
    ELSIF DELETING THEN
        V_EVENT := 'DELETE';
    ELSE
        V_EVENT := 'ERROR';        
    END IF;

   INSERT INTO TB_PROD_HIST (LOG_DATE, WORK_USER, EVENT)
   VALUES (SYSDATE, USER, V_EVENT);   

END;

SELECT *
FROM TB_PROD_HIST;

INSERT INTO TB_PROD (PROD_ID, PROD_NAME, JAN_CNT)
VALUES ('100', 'UHD TV', 0);

INSERT INTO TB_PROD (PROD_ID, PROD_NAME, JAN_CNT)
VALUES ('200', '', 0);

INSERT INTO TB_PROD (PROD_ID, PROD_NAME, JAN_CNT)
VALUES ('300', 'Ź', 0);

DELETE FROM TB_PROD;

SELECT *
FROM TB_PROD_HIST;

SELECT *
FROM  TB_PROD;

COMMIT;

ROLLBACK;

--  Ʈ
--ǰ Ͻ   0̰ 
--Ʈ  (ڽ ̺  Ұ) --10g  ߻(11g, 12c  ƴ)
CREATE OR REPLACE TRIGGER TR_TB_PROD_INSERT
BEFORE INSERT ON TB_PROD
FOR EACH ROW
BEGIN
    
    UPDATE TB_PROD SET JAN_CNT = 0
    WHERE PROD_ID = :NEW.PROD_ID;        

END TR_TB_PROD_INSERT;
/

-- Է
INSERT INTO TB_PROD (PROD_ID, PROD_NAME, JAN_CNT)
VALUES ('100', 'UHD TV', 30);

SELECT * 
FROM TB_PROD;

ROLLBACK;

--Ʈ  AFTER 
CREATE OR REPLACE TRIGGER TR_TB_PROD_INSERT
AFTER INSERT ON TB_PROD
FOR EACH ROW
BEGIN
    
    UPDATE TB_PROD SET JAN_CNT = 0
    WHERE PROD_ID = :NEW.PROD_ID;        

END TR_TB_PROD_INSERT;
/

-- Է
INSERT INTO TB_PROD (PROD_ID, PROD_NAME, JAN_CNT)
VALUES ('100', 'UHD TV', 30);

ROLLBACK;

-- (BEFORE ¿  ġȯ )
CREATE OR REPLACE TRIGGER TR_TB_PROD_INSERT
BEFORE INSERT ON TB_PROD
FOR EACH ROW
BEGIN
    
    DBMS_OUTPUT.PUT_LINE (:NEW.JAN_CNT);
    
    :NEW.JAN_CNT := 0;        

END TR_TB_PROD_INSERT;
/

INSERT INTO TB_PROD (PROD_ID, PROD_NAME, JAN_CNT)
VALUES ('100', 'UHD TV', 10);

INSERT INTO TB_PROD (PROD_ID, PROD_NAME, JAN_CNT)
VALUES ('200', '', 20);

INSERT INTO TB_PROD (PROD_ID, PROD_NAME)
VALUES ('300', 'Ź');

INSERT INTO TB_PROD (PROD_ID, PROD_NAME)
VALUES ('400', '');

COMMIT;

-- Ȯ
SELECT *
FROM TB_PROD;

SELECT *
FROM TB_PROD_HIST;


-- (AFTER   ġȯ   )
CREATE OR REPLACE TRIGGER TR_TB_PROD_INSERT
AFTER INSERT ON TB_PROD
FOR EACH ROW
BEGIN
    
    :NEW.JAN_CNT := 0;        

END TR_TB_PROD_INSERT;
/

-- (INSERT ü OLD    )
--INSERT :NEW, DELETE :OLD, UPDATE :NEW, :OLD
CREATE OR REPLACE TRIGGER TR_TB_PROD_INSERT
AFTER INSERT ON TB_PROD
FOR EACH ROW
BEGIN
    
    :OLD.JAN_CNT := 0;        

END TR_TB_PROD_INSERT;
/

--JAN_CNT Ϸ ϸ  ߻Ű
--Ư ÷ÿ 
CREATE OR REPLACE TRIGGER TR_TB_PROD_UPDATE
BEFORE UPDATE OF JAN_CNT ON TB_PROD
FOR EACH ROW
BEGIN

    --  ߻ (-20001 ~ -20999  )    
    RAISE_APPLICATION_ERROR (-20001, 'ERROR - JAN_CNT  Ұ');

END TR_TB_PROD_UPDATE;
/

UPDATE TB_PROD SET PROD_NAME = 'TEST'
WHERE PROD_ID = '400';

UPDATE TB_PROD SET JAN_CNT = 20
WHERE PROD_ID = '400';

SELECT *
FROM TB_PROD;

ROLLBACK;

--԰̺ Է Ǹ ǰ̺ JAN_CNT   Ű  ϸ 
--ϸ  ߾ ݿ
CREATE OR REPLACE TRIGGER TR_TB_INPUT_ALL
BEFORE INSERT OR UPDATE OR DELETE ON TB_INPUT
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
    V_CNT   PLS_INTEGER;
    INSERT_ERR EXCEPTION;
    UPDATE_ERR EXCEPTION;    
BEGIN
    IF INSERTING THEN
        SELECT COUNT(*)
          INTO V_CNT
          FROM TB_PROD
         WHERE PROD_ID = :NEW.PROD_ID;
        
        IF V_CNT > 0 THEN   
            UPDATE TB_PROD SET JAN_CNT = JAN_CNT + :NEW.IN_CNT
            WHERE PROD_ID = :NEW.PROD_ID;
        ELSE
            DBMS_OUTPUT.PUT_LINE('INSERT TB_INPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND');
            RAISE INSERT_ERR; 
        END IF;
    ELSIF DELETING THEN
        UPDATE TB_PROD SET JAN_CNT = JAN_CNT - :OLD.IN_CNT
        WHERE PROD_ID = :OLD.PROD_ID;
    ELSIF UPDATING THEN
        UPDATE TB_PROD SET JAN_CNT = JAN_CNT - :OLD.IN_CNT
        WHERE PROD_ID = :OLD.PROD_ID;
        
        SELECT COUNT(*)
          INTO V_CNT
          FROM TB_PROD
         WHERE PROD_ID = :NEW.PROD_ID;
        
        IF V_CNT > 0 THEN   
            UPDATE TB_PROD SET JAN_CNT = JAN_CNT + :NEW.IN_CNT
            WHERE PROD_ID = :NEW.PROD_ID;
        ELSE
            DBMS_OUTPUT.PUT_LINE('UPDATE TB_INPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND');
            RAISE UPDATE_ERR;             
        END IF;
        --ǰ ٲ ϰ ڸ  ϴٸ  ü 
        /* 
        UPDATE TB_PROD SET JAN_CNT = JAN_CNT - :OLD.IN_CNT + :NEW.IN_CNT
        WHERE PROD_ID = :OLD.PROD_ID;
        */
    END IF;
    
EXCEPTION
    WHEN INSERT_ERR THEN
        RAISE_APPLICATION_ERROR (-20001, 'INSERT TB_INPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND'); 
    WHEN UPDATE_ERR THEN
        RAISE_APPLICATION_ERROR (-20999, 'UPDATE TB_INPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND');     

END TR_TB_INPUT_ALL;

--׽Ʈ Է : Ʈžȿ ۵Ǵ 뵵 ݿ
INSERT INTO TB_INPUT (IN_DATE, IN_SEQ, PROD_ID, IN_CNT)
VALUES ('2015-01-01', '001', '100', 5);

--Ʈ Ȱȭ
ALTER TRIGGER TR_TB_PROD_UPDATE DISABLE;

--Ʈ ۽
INSERT INTO TB_INPUT (IN_DATE, IN_SEQ, PROD_ID, IN_CNT)
VALUES ('2015-01-01', '001', '100', 5);

--Ἲ  Ǻ Ʈ    (BEFORE) AFTER ٸ Ŀ ݿ
INSERT INTO TB_INPUT (IN_DATE, IN_SEQ, PROD_ID, IN_CNT)
VALUES ('2015-01-01', '001', '101', 5);

INSERT INTO TB_INPUT (IN_DATE, IN_SEQ, PROD_ID, IN_CNT)
VALUES ('2015-01-01', '001', '200', 5);

--AFTER Ʈŷ ش  
CREATE OR REPLACE TRIGGER TR_TB_INPUT_ALL
AFTER INSERT OR UPDATE OR DELETE ON TB_INPUT
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
    V_CNT   PLS_INTEGER;
    INSERT_ERR EXCEPTION;
    UPDATE_ERR EXCEPTION;    
BEGIN
    IF INSERTING THEN
        SELECT COUNT(*)
          INTO V_CNT
          FROM TB_PROD
         WHERE PROD_ID = :NEW.PROD_ID;
        
        IF V_CNT > 0 THEN   
            UPDATE TB_PROD SET JAN_CNT = JAN_CNT + :NEW.IN_CNT
            WHERE PROD_ID = :NEW.PROD_ID;
        ELSE
            DBMS_OUTPUT.PUT_LINE('INSERT TB_INPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND');
            RAISE INSERT_ERR; 
        END IF;
    ELSIF DELETING THEN
        UPDATE TB_PROD SET JAN_CNT = JAN_CNT - :OLD.IN_CNT
        WHERE PROD_ID = :OLD.PROD_ID;
    ELSIF UPDATING THEN
        UPDATE TB_PROD SET JAN_CNT = JAN_CNT - :OLD.IN_CNT
        WHERE PROD_ID = :OLD.PROD_ID;
        
        SELECT COUNT(*)
          INTO V_CNT
          FROM TB_PROD
         WHERE PROD_ID = :NEW.PROD_ID;
        
        IF V_CNT > 0 THEN   
            UPDATE TB_PROD SET JAN_CNT = JAN_CNT + :NEW.IN_CNT
            WHERE PROD_ID = :NEW.PROD_ID;
        ELSE
            DBMS_OUTPUT.PUT_LINE('UPDATE TB_INPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND');
            RAISE UPDATE_ERR;             
        END IF;
        --ǰ ٲ ϰ ڸ  ϴٸ  ü 
        /* 
        UPDATE TB_PROD SET JAN_CNT = JAN_CNT - :OLD.IN_CNT + :NEW.IN_CNT
        WHERE PROD_ID = :OLD.PROD_ID;
        */
    END IF;
    
EXCEPTION
    WHEN INSERT_ERR THEN
        RAISE_APPLICATION_ERROR (-20001, 'INSERT TB_INPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND'); 
    WHEN UPDATE_ERR THEN
        RAISE_APPLICATION_ERROR (-20999, 'UPDATE TB_INPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND');     

END TR_TB_INPUT_ALL;

--Ἲ   Ʈ    (AFTER)
INSERT INTO TB_INPUT (IN_DATE, IN_SEQ, PROD_ID, IN_CNT)
VALUES ('2015-01-01', '001', '101', 5);

-- ()
UPDATE TB_INPUT SET PROD_ID = '200'
WHERE IN_DATE = '2015-01-01'
AND IN_SEQ = '001';

-- ()
UPDATE TB_INPUT SET PROD_ID = '300', IN_CNT = 4
WHERE IN_DATE = '2015-01-01'
AND IN_SEQ = '001';

SELECT *
FROM TB_PROD;

SELECT *
FROM TB_INPUT;

ROLLBACK;

--̺ Է Ǹ ǰ̺ JAN_CNT   Ű  ϸ ְ ϸ  ߾ ݿ
CREATE OR REPLACE TRIGGER TR_TB_OUTPUT_ALL
BEFORE INSERT OR UPDATE OR DELETE ON TB_OUTPUT
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
    V_CNT   PLS_INTEGER;
    INSERT_ERR EXCEPTION;
    UPDATE_ERR EXCEPTION;
BEGIN
    IF INSERTING THEN
        SELECT COUNT(*)
          INTO V_CNT
          FROM TB_PROD
         WHERE PROD_ID = :NEW.PROD_ID;
        
        IF V_CNT > 0 THEN   
            UPDATE TB_PROD SET JAN_CNT = JAN_CNT - :NEW.OUT_CNT
            WHERE PROD_ID = :NEW.PROD_ID;
        ELSE
            DBMS_OUTPUT.PUT_LINE('INSERT TB_OUTPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND');
            RAISE INSERT_ERR;             
        END IF;
    ELSIF DELETING THEN
    
        UPDATE TB_PROD SET JAN_CNT = JAN_CNT + :OLD.OUT_CNT
        WHERE PROD_ID = :OLD.PROD_ID;
        
    ELSIF UPDATING THEN
        UPDATE TB_PROD SET JAN_CNT = JAN_CNT + :OLD.OUT_CNT
        WHERE PROD_ID = :OLD.PROD_ID;
        
        SELECT COUNT(*)
          INTO V_CNT
          FROM TB_PROD
         WHERE PROD_ID = :NEW.PROD_ID;
        
        IF V_CNT > 0 THEN   
            UPDATE TB_PROD SET JAN_CNT = JAN_CNT - :NEW.OUT_CNT
            WHERE PROD_ID = :NEW.PROD_ID;
        ELSE
            DBMS_OUTPUT.PUT_LINE('UPDATE TB_OUTPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND');
            RAISE UPDATE_ERR; 
            
        END IF;
        --ǰ ٲ ϰ ڸ  ϴٸ  ü  
        --UPDATE TB_PROD SET JAN_CNT = JAN_CNT - :OLD.IN_CNT + :NEW.IN_CNT
        --WHERE PROD_ID = :OLD.PROD_ID;
        
    END IF;
EXCEPTION
    WHEN INSERT_ERR THEN
        RAISE_APPLICATION_ERROR (-20001, 'INSERT TB_OUTPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND'); 
    WHEN UPDATE_ERR THEN
        RAISE_APPLICATION_ERROR (-20999, 'UPDATE TB_OUTPUT ERROR - ' || :NEW.PROD_ID || ' NOT FOUND');

END TR_TB_OUTPUT_ALL;

--׽Ʈ Է
INSERT INTO TB_INPUT (IN_DATE, IN_SEQ, PROD_ID, IN_CNT)
VALUES ('2015-01-01', '002', '200', 5);

INSERT INTO TB_OUTPUT (OUT_DATE, OUT_SEQ, PROD_ID, OUT_CNT)
VALUES ('2015-01-01', '001', '100', 4);

SELECT *
FROM TB_PROD;

COMMIT;

--DDL Ʈ ׽Ʈ
--DROP TABLE TB_DDL_HISTORY;

CREATE TABLE TB_DDL_HISTORY (
    LOG_DATE    TIMESTAMP,
    USER_ID     VARCHAR2(100)
);

--DROP TRIGGER CTEST.TR_TEST_DDL;

CREATE OR REPLACE TRIGGER TR_TEST_DDL
BEFORE DDL
ON HR.SCHEMA
BEGIN

   INSERT INTO TB_DDL_HISTORY (LOG_DATE, USER_ID)
   VALUES (SYSDATE, USER);   

END ;
/

--̺  TEST
CREATE TABLE TB_TEST_DDL (
    KEY_01  VARCHAR2(10),
    COL_01  VARCHAR2(10)
);

ALTER TABLE TB_TEST_DDL
ADD COL_02 VARCHAR2(50);

DROP TABLE TB_TEST_DDL;


SELECT *
FROM TB_DDL_HISTORY;

ROLLBACK;

--Ʈ  Ȱȭ
ALTER TRIGGER TR_TEST_DDL DISABLE;

--Ʈ  Ȱȭ
ALTER TRIGGER TR_TEST_DDL ENABLE;

--̺  Ʈ Ȱȭ
ALTER TABLE TB_PROD DISABLE ALL TRIGGERS;

--̺  Ʈ Ȱȭ
ALTER TABLE TB_PROD ENABLE ALL TRIGGERS;

--Ʈ 
DROP TRIGGER TR_TB_PROD_UPDATE;
